(use lazy-ssax)
(use sxml-tools-extra)

(print "--- Lazy XML-to-SXML conversion")
(define doc (lazy:xml->sxml (open-input-file "poem.xml")
							'()))
(pp doc)

; (print "--- Entire lazy SXML document")
; (pp (cdr (lazy:result->list doc)))

(print "--- Forced promise")
(pp (force (cadddr (caddr doc))))

(print "--- Querying a lazy SXML document, lazily")
(define res ((lazy:sxpath "poem/stanza/line[1]") doc))
(pp res)

(print "--- Obtain the next portion of the result")
(pp (force (cadr res)))

(print "--- Converting the lazy result to a conventional SXML nodeset")
(pp (lazy:result->list res))

